#include "display_joystick.h"
#include <stdbool.h>

// Hack fr C, weil const hier nicht so funktioniert wie in C++.
enum Konstanten {ANZAHL_REIHEN = 4, MINIMUM = 2, MAXIMUM = 7, ANZAHL_BITS = 3};

void gibAus(int hoelzer[], int aktuelleReihe)
{
  char ausgabe[] = "        ";
  for(int i = 0; i < ANZAHL_REIHEN; i++)
  {
    ausgabe[2 * i + 1] = '0' + hoelzer[i];
    if(aktuelleReihe >= 0)
    {
      ausgabe[2 * aktuelleReihe] = '>';
    }
  }
  writeString(ausgabe);
}

bool sindAlleReihenLeer(int hoelzer[])
{
    for(int i = 0; i < ANZAHL_REIHEN; i++)
    {
      if(hoelzer[i] != 0)
      {
        return false;
      }
    }
    return true;
}

unsigned int rand(void)
{
  // Dies ist kein Zufallsgenerator fr ernsthafte Aufgaben!
  static unsigned int a = 12345;
  a = (a * 4567) % 4321;
  return a;
}

int main( void )
{
  initialize();
  
  while(true)
  {
    int hoelzer[ANZAHL_REIHEN];
    for(int i = 0; i < ANZAHL_REIHEN; i++)
    {
      hoelzer[i] = MINIMUM + rand() % (MAXIMUM - MINIMUM + 1);
    }

    bool spielZuEnde = false;
    while(!spielZuEnde)
    {
      int aktuelleReihe = 0;
      gibAus(hoelzer, aktuelleReihe);
      bool etwasGenommen = false;
      
      while(!etwasGenommen)
      {
        do
        {
          if(readAnalog(0) > 700)
          {
            while(readAnalog(0) > 600)
            {}
            if(aktuelleReihe < ANZAHL_REIHEN - 1)
            {
              aktuelleReihe++;
              gibAus(hoelzer, aktuelleReihe);
            }
          }
        }
        while(readAnalog(1) > 300);
        
        do
        {
          if(readAnalog(1) < 300)
          {
            while(readAnalog(1) < 400)
            {}
            if(hoelzer[aktuelleReihe] > 0)
            {
              hoelzer[aktuelleReihe]--;
              etwasGenommen = true;
              gibAus(hoelzer, aktuelleReihe);
            }
          }
        }
        while(readAnalog(1) < 700);

        while(readAnalog(1) > 600)
        {}
      }
      
      if(sindAlleReihenLeer(hoelzer))
      {
        writeString("Du gew.");
        spielZuEnde = true;
        waitMilliseconds(1000);
      }
      else
      {
        bool bitParitaeten[ANZAHL_BITS] = {false};
        for(int i = 0; i < ANZAHL_REIHEN; i++)
        {
          for(int j = 0; j < ANZAHL_BITS; j++)
          {
            if((hoelzer[i] & (1 << j)) != 0)
            {
              bitParitaeten[j] = !bitParitaeten[j];
            }
          }
        }
        
        int hoechstesBit = -1;
        int summe = 0;
        for(int i = 0; i < ANZAHL_BITS; i++)
        {
          if(bitParitaeten[i])
          {
            hoechstesBit = i;
            summe += (1 << i);
          }
        }
        
        // Sind wir in Verluststellung?
        if(hoechstesBit < 0)
        {
          // Dann irgendetwas tun.
          for(int i = 0; i < ANZAHL_REIHEN; i++)
          {
            if(hoelzer[i] > 0)
            {
              hoelzer[i]--;
              break;
            }
          }
        }
        else // Wir sind in Gewinnstellung.
        // Mache die Paritten zu null!
        {
          for(int i = 0; i < ANZAHL_REIHEN; i++)
          {
            if((hoelzer[i] & (1 << hoechstesBit)) != 0)
            {
              
              hoelzer[i] ^= summe;
              break;
            }
          }          
        }
        
        gibAus(hoelzer, -1);
        waitMilliseconds(500);

        if(sindAlleReihenLeer(hoelzer))
        {
          writeString("Ich gew.");
          spielZuEnde = true;
          waitMilliseconds(1000);
        }
      }
    }
  }
  //return 0;
}